"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Hooks = void 0;
exports.hookAdapterFactory = hookAdapterFactory;
var Hooks = {
  MESSAGE_BEFORE_SENT: 'message::before-sent',
  MESSAGE_BEFORE_RECEIVED: 'message::before-received'
};
exports.Hooks = Hooks;

function hookAdapterFactory() {
  var hooks = {};

  var get = function get(key) {
    if (!Array.isArray(hooks[key])) hooks[key] = [];
    return hooks[key];
  };

  function intercept(hook, callback) {
    get(hook).push(callback);
    var index = get(hook).length;
    return function () {
      return get(hook).splice(index, 1);
    };
  }

  function trigger(hook, payload) {
    return get(hook).reduce(function (acc, fn) {
      return Promise.resolve(acc).then(fn);
    }, Promise.resolve(payload));
  }

  return {
    trigger: trigger,
    intercept: intercept
  };
}