"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = UrlBuilder;

function UrlBuilder(basePath) {
  var params = {};

  var getQuery = function getQuery(key, value) {
    return "".concat(key, "=").concat(value);
  };

  return {
    param: function param(key, value) {
      params[key] = value;
      return this;
    },
    build: function build() {
      var query = Object.keys(params).filter(function (key) {
        return params[key] != null;
      }).map(function (key) {
        if (Array.isArray(params[key])) {
          return params[key].map(function (value) {
            return getQuery("".concat(key, "[]"), value);
          }).join("&");
        }

        return getQuery(key, params[key]);
      }).join("&");
      return [basePath].concat(query).join("?");
    }
  };
}

module.exports = exports.default;