"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wrapP = exports.tryCatch = void 0;

var tryCatch = function tryCatch(fn, default_, onError, onSuccess) {
  try {
    var resp = fn();
    if (onSuccess != null) onSuccess(resp);
    return resp;
  } catch (error) {
    if (onError != null) onError(error);
    return default_;
  }
};

exports.tryCatch = tryCatch;

var wrapP = function wrapP(promise) {
  return promise.then(function (res) {
    return [res, null];
  })["catch"](function (err) {
    return [null, err];
  });
};

exports.wrapP = wrapP;